module TwoFactorDevices
  # phone device - store phone number as value
  class PhoneDevice < TwoFactorDevice
    VALUE_MASK = /(?<=.{3})[0-9](?=.{2})/.freeze

    before_validation :prepare_value
    validates :value, numericality: { only_integer: true }

    def prepare_value
      value.gsub(/\D/, '')
    end
  end
end
