module TwoFactorDevices
  module Extensions
    # model extension for device's owner AR class
    module TwoFactorDeviceble
      extend ActiveSupport::Concern

      included do
        has_many :two_factor_devices,
                 dependent: :destroy,
                 class_name: 'TwoFactorDevices::TwoFactorDevice',
                 inverse_of: :owner,
                 foreign_key: :owner_id
      end

      def primary_two_factor_device
        @primary_two_factor_device ||= two_factor_devices.confirmed.default.first ||
                                       two_factor_devices.confirmed.order(:id).first
      end
    end
  end
end
